//+------------------------------------------------------------------+
//| August 2003 issue |
//| Technical Analysis of Stocks and Commodities |
//| Giorgos Siligardos' article "Reverse Engineering RSI (II) |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link "mladenfx@gmail.com"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  DarkViolet
#property indicator_width1  2

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame  = PERIOD_CURRENT;
extern int                EmaPeriod  = 45;
extern int                WildPeriod = 14;
extern ENUM_APPLIED_PRICE Price      = PRICE_CLOSE;
extern int                Shift      = 1;

double ema[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,ema); SetIndexShift(0,Shift);
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   for (int i=0; i<3; i++) SetIndexShift(i,Shift*TimeFrame/Period());
   
   IndicatorShortName(timeFrameToString(TimeFrame)+" rev eng rsi");
return(0);
}
int deinit(){return(0);}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
      int limit = MathMin(Bars-counted_bars,Bars-1);
      if (returnBars)  { ema[0] = limit+1; return(0); } 

      //
      //
      //
      //
      //
      
      if (TimeFrame == Period())
      {  
        for(int i=limit; i>=0; i--)
        {
           double price  = iMA(NULL,0,1,0,MODE_SMA,Price,i);
           double price1 = iMA(NULL,0,1,0,MODE_SMA,Price,i+1);
           double emaRsi = iEma(iRSI(NULL,0,WildPeriod,Price,i),EmaPeriod-1,i,0);
           double value1 = 0; if (price>price1) value1 = price-price1;
           double value2 = 0; if (price1>price) value2 = price1-price;
           double aup = iEma(value1,WildPeriod,i,1);
           double adp = iEma(value2,WildPeriod,i,2);

           //
           //
           //
           //
           //

           if ((100.0-emaRsi)!=0)
             double x = (WildPeriod-1.0)*(adp*emaRsi/(100.0-emaRsi)-aup);
             else x   = 0; 
             if (x>=0) ema[i] = price+x;
             else 
             if (emaRsi!=0)
                  ema[i] = price+x*(100-emaRsi)/emaRsi;
             else ema[i] = price;
   }
   return(0);
   }
   
   //
   //
   //
   //
   //
 
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i >= 0; i--)  
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         ema[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,EmaPeriod,WildPeriod,Price,0,y);       
   }
return(0); 
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][3];
double iEma(double price, double period, int r, int instanceNo=0)
{
      if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

      //
      //
      //
      //
      //

      double alpha = 2.0 / (1.0+period);
      workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
return(workEma[r][instanceNo]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
